<?php
/*
Plugin Name: Word Replacer
Plugin URI: http://takien.com/587/word-replacer-wordpress-plugin.php
Description: Replace word in post, page, title or comment. Now with RegEx supports.
Author: Takien
Version: 0.2.1
Author URI: http://takien.com/
*/

/*  Copyright 2010 takien.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    For a copy of the GNU General Public License, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if(!defined('ABSPATH')) die();

global $wpdb;
global $word_replacer;

$word_replacer = Array(
				'name' 			=> 'Word Replacer',
				'version' 		=> '0.2.1',
				'table_name'	=> $wpdb->prefix . "word_replacer",
				'base_name'		=> 'wordreplacer'
);

function _specialchar($string) {
	return htmlspecialchars(stripcslashes($string));
}

if(isset($_POST['submit'])) {
	$id				= $_POST['id'];
	$original 		= $_POST['original']; //do not stripslashes_deep, base_64 encode then. (ver 0.2)
	$replacement 	= stripslashes_deep($_POST['replacer']);
	$in_posts 		= $_POST['in_posts'];
	$in_comments	= $_POST['in_comments'];
	$in_pages		= $_POST['in_pages'];
	$in_titles		= $_POST['in_titles'];
	$in_sensitive	= $_POST['in_sensitive'];
	$in_wordonly	= $_POST['in_wordonly'];
	$in_regex		= $_POST['in_regex'];
	
	
	$numfield = array_diff($original,Array(''));
	$numfield = count($numfield);
	
	
	for ($i = 0; $i <= $numfield; $i++) {
	
	$in_posts[$i] 		= (empty($in_posts[$i]) ? 'no' : $in_posts[$i]);
	$in_comments[$i] 	= (empty($in_comments[$i]) ? 'no' : $in_comments[$i]);
	$in_pages[$i] 		= (empty($in_pages[$i]) ? 'no' : $in_pages[$i]);
	$in_titles[$i] 		= (empty($in_titles[$i]) ? 'no' : $in_titles[$i]);
	$in_sensitive[$i] 	= (empty($in_sensitive[$i]) ? 'no' : $in_sensitive[$i]);
	$in_wordonly[$i] 	= (empty($in_wordonly[$i]) ? 'no' : $in_wordonly[$i]);
	$in_regex[$i] 		= (empty($in_regex[$i]) ? 'no' : $in_regex[$i]);
	
	if(!empty($original[$i]) && empty($id[$i])) {
	
	$wpdb->query($wpdb->prepare( "
		INSERT INTO ".$word_replacer['table_name']." 
		(original, replacement, in_posts, in_comments, in_pages, in_titles, in_sensitive, in_wordonly, in_regex)
		VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s)",
		array($wpdb->escape(base64_encode($original[$i])),$wpdb->escape($replacement[$i]),$wpdb->escape($in_posts[$i]),$wpdb->escape($in_comments[$i]),$wpdb->escape($in_pages[$i]),$wpdb->escape($in_titles[$i]),$wpdb->escape($in_sensitive[$i]),$wpdb->escape($in_wordonly[$i]),$wpdb->escape($in_regex[$i])))); 
		$message =  '<div id="message" class="updated fade"><p><strong>Word Inserted.</strong></p></div>';

	}
	elseif(empty($original[$i]) && !empty($id[$i])) {
		$wpdb->query("
		DELETE FROM ".$word_replacer['table_name']." WHERE id = '".$id[$i]."'");
		$message =  '<div id="message" class="updated fade"><p><strong>Word Deleted.</strong></p></div>';
	}
	elseif(!empty($original[$i]) && !empty($id[$i])) {
		$wpdb->update($word_replacer['table_name'], 
		array('original' 	=> $wpdb->escape(base64_encode($original[$i])),
		'replacement' 		=> $wpdb->escape($replacement[$i]),
		'in_posts'			=> $wpdb->escape($in_posts[$i]),
		'in_comments'		=> $wpdb->escape($in_comments[$i]),
		'in_pages'			=> $wpdb->escape($in_pages[$i]),
		'in_titles'			=> $wpdb->escape($in_titles[$i]),
		'in_sensitive'		=> $wpdb->escape($in_sensitive[$i]),
		'in_wordonly'		=> $wpdb->escape($in_wordonly[$i]),
		'in_regex'			=> $wpdb->escape($in_regex[$i])
		),
		array('id' => $id[$i]), array('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'), array('%d'));
		$message = '<div id="message" class="updated fade"><p><strong>Word Updated.</strong></p></div>';
	}
	}
}

function word_replacer_install () {
	global $wpdb;
	global $word_replacer;

	$sql = "CREATE TABLE " . $word_replacer['table_name'] . " (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  original TEXT NOT NULL,
	  replacement TEXT NOT NULL,
	  in_posts VARCHAR(5) NOT NULL,
	  in_comments VARCHAR(5) NOT NULL,
	  in_pages VARCHAR(5) NOT NULL,
	  in_titles VARCHAR(5) NOT NULL,
	  in_sensitive VARCHAR(5) NOT NULL,
	  in_wordonly VARCHAR(5) NOT NULL,
	  in_regex VARCHAR(5) NOT NULL,
	  UNIQUE KEY id (id)
	);";

     require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	  
if($wpdb->get_var('show tables like "'.$word_replacer['table_name'].'"') !== $word_replacer['table_name']) {
	dbDelta($sql);
	add_option("word_replacer_ver", $word_replacer['version']);
}
elseif (get_option("word_replacer_ver") !== $word_replacer['version']) {
	dbDelta($sql);
	update_option("word_replacer_ver", $word_replacer['version']);
}
}

register_activation_hook(__FILE__,'word_replacer_install');

function word_replacer_db() {
	global $wpdb;
	global $word_replacer;
	return $wpdb->get_results("SELECT * FROM ".$word_replacer['table_name']." ORDER BY id", ARRAY_A);
}

//use preg_replace
function replace_replace($original='',$replacement='',$in_sensitive='',$in_wordonly='',$in_regex='',$string='') {
if($in_wordonly == 'yes') 	$b ='\b';
if($in_sensitive == 'yes') 	$i ='i';
$original = ($in_regex == 'yes') ? $original : preg_quote($original);
return preg_replace("/$b$original$b/$i",$replacement,$string);
}

// for content, post and page
function word_replacer_postpage($content) {
$i = 1;
foreach(word_replacer_db() as $wrdb) {
$i++;
	$original[$i] 		= base64_decode($wrdb['original'],true)?base64_decode($wrdb['original']):$wrdb['original'];
	$replacement[$i] 	= htmlspecialchars_decode(_specialchar($wrdb['replacement']));
	$in_posts[$i] 		= $wrdb['in_posts'];
	$in_pages[$i] 		= $wrdb['in_pages'];
	$in_sensitive[$i] 	= $wrdb['in_sensitive'];
	$in_wordonly[$i]	= $wrdb['in_wordonly'];
	$in_regex[$i]		= $wrdb['in_regex'];
	
	if(is_page() && ($in_pages[$i] == 'yes')) {
	$content = replace_replace($original[$i],$replacement[$i],$in_sensitive[$i],$in_wordonly[$i],$in_regex[$i],$content);
	}
	elseif(!is_page() && ($in_posts[$i] == 'yes')) {
		$content = replace_replace($original[$i],$replacement[$i],$in_sensitive[$i],$in_wordonly[$i],$in_regex[$i],$content);
	}
}
return $content;
}

// for comment
function word_replacer_comment($content) {
$i = 1;
foreach(word_replacer_db() as $wrdb) {
$i++;
	$original[$i] = base64_decode($wrdb['original'],true)?base64_decode($wrdb['original']):$wrdb['original'];
	$replacement[$i] 	= stripslashes($wrdb['replacement']);
	$in_comments[$i] 	= $wrdb['in_comments'];
	$in_sensitive[$i] 	= $wrdb['in_sensitive'];
	$in_wordonly[$i]	= $wrdb['in_wordonly'];
	$in_regex[$i]		= $wrdb['in_regex'];

	if($in_comments[$i]	== 'yes') {
	$content = replace_replace($original[$i],$replacement[$i],$in_sensitive[$i],$in_wordonly[$i],$in_regex[$i],$content);
	}
	}
return $content;
}

// for titles
function word_replacer_title($content) {
$i = 1;
foreach(word_replacer_db() as $wrdb) {
$i++;
	$original[$i] 		= base64_decode($wrdb['original'],true)?base64_decode($wrdb['original']):$wrdb['original'];
	$replacement[$i] 	= stripslashes($wrdb['replacement']);
	$in_titles[$i] 		= $wrdb['in_titles'];
	$in_sensitive[$i] 	= $wrdb['in_sensitive'];
	$in_wordonly[$i]	= $wrdb['in_wordonly'];
	$in_regex[$i]		= $wrdb['in_regex'];

	if($in_titles[$i]	== 'yes') {
	$content = replace_replace($original[$i],$replacement[$i],$in_sensitive[$i],$in_wordonly[$i],$in_regex[$i],$content);
	}
	}
return $content;
}

//for page title
function word_replacer_pagetitle($content){
$i = 1;
foreach(word_replacer_db() as $wrdb) { $i++;
	$original[$i] 		= base64_decode($wrdb['original'],true)?base64_decode($wrdb['original']):$wrdb['original'];
	$replacement[$i] 	= stripslashes($wrdb['replacement']);
	$in_titles[$i] 		= $wrdb['in_titles'];
	$in_sensitive[$i] 	= $wrdb['in_sensitive'];
	$in_wordonly[$i]	= $wrdb['in_wordonly'];
	$in_regex[$i]		= $wrdb['in_regex'];

	if($in_titles[$i]	== 'yes') {
	$content = replace_replace($original[$i],$replacement[$i],$in_sensitive[$i],$in_wordonly[$i],$in_regex[$i],$content);
	}
	}
return $content;
}

function word_replacer_settings_link($links) {
global $word_replacer;
  $settings_link = '<a href="options-general.php?page='.$word_replacer['base_name'].'">Settings</a>';
  array_unshift($links, $settings_link);
  return $links;
}

/*contextual help*/
function word_replacer_help($help) {
global $word_replacer;
$page = $_GET['page'];

if($page == $word_replacer['base_name']) {
	$help = '<h5>Instruction:</h5>
<ol>
<li>To <strong>Add New Word</strong> click Add More Fields  add your word, replacement and filter, then hit Add/Update Words.</li>
<li>To <strong>Update</strong> a word, just replace/retype in it\'s place an hit Add/Update Words.</li>
<li>To <strong>Delete</strong> a word, leave blank/clear word in "original" field and hit Add/Update Words.</li></ol>
<h5>Regex:</h5>
<ol>
<li>Do not use delimiter "/" in the begining and the end of each REGEX pattern. It will be added when it\'s processed.</li>
<li>The REGEX options <em>i</em> also will be added automatically if you check Case Insensitive on</li>
</ol>
<p>Question, suggestion, comment, or help please <a href="http://takien.com/587/word-replacer-wordpress-plugin.php" target="_blank">go here.</a></p>
<p>Support is limited to plugins usage and feature only, for advanced info about RegEx and preg_replace please
refers to the following resources:</p>
<ol>
<li>Regex info <a href="http://www.regular-expressions.info/" target="_blank">http://www.regular-expressions.info/</a></li>
<li>preg_replace function <a href="http://www.php.net/manual/en/function.preg-replace.php" target="_blank">http://www.php.net/manual/en/function.preg-replace.php</a></li>
</ol>
';
}
return $help;
}

$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'word_replacer_settings_link' );
add_filter('comment_text','word_replacer_comment');
add_filter('the_content','word_replacer_postpage');
add_filter('the_title','word_replacer_title');
add_filter('wp_title', 'word_replacer_pagetitle');
add_action('admin_menu', 'word_replacer_add_page');
add_action('contextual_help', 'word_replacer_help');

function word_replacer_add_page() {
	global $word_replacer;
    add_options_page($word_replacer['name'], $word_replacer['name'], 'administrator', $word_replacer['base_name'], 'word_replacer_page');
}

function word_replacer_page() {
	global $wpdb, $word_replacer, $message;
	
	echo '<div class="wrap">
	<h2>'.$word_replacer['name'].'</h2>';
	echo $message;

$basefield = "<tr><td><input type='hidden' name='id[]' value='' /><input type='hidden' name='id[]' value='' /><input style='width:100%' name='original[]' type='text' /></td><td> &raquo; </td><td><input  style='width:100%' name='replacer[]' type='text' /></td><td><input value='yes' name='in_posts[]' type='checkbox' /></td><td><input value='yes' name='in_comments[]' type='checkbox' /></td><td><input value='yes' name='in_pages[]' type='checkbox' /></td><td><input value='yes' name='in_titles[]' type='checkbox' /></td><td><input value='yes' name='in_sensitive[]' type='checkbox' /></td><td><input value='yes' name='in_wordonly[]' type='checkbox' /></td><td ><input value='yes' name='in_regex[]' type='checkbox' /></td></tr>";
?>
	
<script language="Javascript" type="text/javascript">
<!--
function addField(area) {
	if(!document.getElementById) return;
	var field_area = document.getElementById(area);
	var nomor = document.getElementsByName("count");
	var count = nomor.length;
	field_area.innerHTML += "<tr><td><input type='hidden' name='id["+count+"]' value='' /><input type='hidden' name='count' value='' /><input style='width:100%' name='original["+count+"]' value='' type='text' /></td>\n<td> &raquo; </td>\n<td><input  style='width:100%' name='replacer["+count+"]' type='text' /></td>\n<td></td>\n<td class='replacer_expandable'><input value='yes' name='in_posts["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_comments["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_pages["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_titles["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_sensitive["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_wordonly["+count+"]' type='checkbox' /></td>\n<td class='replacer_expandable'><input value='yes' name='in_regex["+count+"]' type='checkbox' /></td></tr>\n";
}
jQuery(document).ready(function($){
$('.replacer_expandall a').click(function(){
$('.replacer_expandable').toggle();return false;});
});
//-->

</script>
<?php
$action_url = $_SERVER[PHP_SELF] . '?page=' . $word_replacer['base_name'];
?>

<p>Put the word to be replaced on the left, and what to change it to on the right.</p>
<form method="post" action="<?php echo $action_url;?>">
<table class="widefat fixed" width="650" align="center" width="100%" id="word-replacer-list">
<thead>
<?php wp_nonce_field('update-options'); ?>

<tr><th>Original</th><th width="5">&nbsp;</th><th>Replacement</th>
<th class="replacer_expandall" width="20"><a style="color:black" href="#" title="Expand/Collapse">&laquo;&raquo;</a></th><th class="replacer_expandable" width="40">Posts</th><th class="replacer_expandable" width="70">Comments</th><th class="replacer_expandable" width="40">Pages</th><th class="replacer_expandable" width="40">Titles</th><th class="replacer_expandable" width="80">Insensitive</th><th class="replacer_expandable" width="80">Whole Word</th><th class="replacer_expandable" width="40">Regex</th></tr>
</thead>
<?php 
$i = -1;
if(is_array(word_replacer_db())) {
foreach(word_replacer_db() as $wrdb) { $i++ ?>
<?php $alternate = (empty($alternate) ? 'class="alternate"' : '');?>
<tr <?php echo $alternate;?>><td>
<input type="hidden" name="id[<?php echo $i;?>]" value="<?php echo $wrdb['id']; ?>" />
<input type="hidden" name="count" value="" />
<input style="width:100%" type="text" name="original[<?php echo $i;?>]" id="original_<?php echo $i;?>" value="<?php echo htmlspecialchars(base64_decode($wrdb['original'],true)?base64_decode($wrdb['original']):$wrdb['original']) ?>" /></td><td> &raquo; </td>
<td><input style="width:100%" type="text" name="replacer[<?php echo $i;?>]" value="<?php echo _specialchar($wrdb['replacement']) ?>" /></td>
<td></td>
<td class="replacer_expandable">
	<input value="yes" name="in_posts[<?php echo $i;?>]" <?php echo (($wrdb['in_posts'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_comments[<?php echo $i;?>]" <?php echo (($wrdb['in_comments'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_pages[<?php echo $i;?>]" <?php echo (($wrdb['in_pages'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_titles[<?php echo $i;?>]" <?php echo (($wrdb['in_titles'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_sensitive[<?php echo $i;?>]" <?php echo (($wrdb['in_sensitive'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_wordonly[<?php echo $i;?>]" <?php echo (($wrdb['in_wordonly'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
<td class="replacer_expandable">
	<input value="yes" name="in_regex[<?php echo $i;?>]" <?php echo (($wrdb['in_regex'] == 'yes') ? 'checked="checked"' : ''); ?> type="checkbox" /></td>
</tr>

<?php }
}
else {
	echo $basefield;
}
?>

</table>

<input type="button" value="+ Add More Fields" style="cursor:pointer" onclick="addField('word-replacer-list')" />
<input type="hidden" name="action" value="update" /> 
<input name="submit" class="button-primary" type="submit" value="<?php _e('Add/Update Words') ?>" />

</form>

</div>

<?php
}
?>